// ======================================================================
//
// ProfileTime.h
// jeff grills
//
// copyright 1996 origin systems inc
//
// ======================================================================

#ifndef PROFILE_TIME_H
#define PROFILE_TIME_H

// ======================================================================

#define USE_PROFILE_PENTIUM 0

// ======================================================================

typedef __int64 ProfileTime;

// ======================================================================

#if USE_PROFILE_PENTIUM

inline void getProfileTime(ProfileTime *t)
{
	__asm
	{
		// load the clock timings into edx:eax
		__emit 0x0f
		__emit 0x31

		// store the time
		mov ebx,     [t]
		mov [ebx],   eax
		mov [ebx+4], edx

		// here we explicitly destroy the contents of eax and edx so the
		// compiler knows these registers were trashed.  otherwise, it may
		// have no knowledge that the unlisted opcode above trashed them.
		// this avoids compiler optimization bugs.
		xor eax, eax
		xor edx, edx
	}
}

#else

inline void getProfileTime(ProfileTime *t)
{
	QueryPerformanceCounter(reinterpret_cast<LARGE_INTEGER *>(t));
}

#endif

// ======================================================================

#endif
